system module _SystemArray

class Array .a
where
	_createArrayc 		:: !Int -> . (a .e)							| createArrayc_u e
	_updatei			:: !(!*(a .e),!*r) !Int .e -> *r	 		| updatei_u e
	_uselectf			:: ! u:(a .e) !Int -> (.e, ! u:(a .e))		| uselectf_u e
	_uselectl			:: !(!.(a e ),!.r) !.Int -> (e,!.r)			| uselectl_u e
	_uselectn			:: !(!.(a .e),!.r) !.Int -> (.e,!.r)		| uselectn_u e
	createArray			:: !Int e -> . (a e)						| createArray_u e
	replace				:: !* (a .e) !Int .e -> (.e, ! * (a .e))	| replace_u e
	select				:: ! .(a .e) !Int -> .e 					| select_u e
	size				:: ! .(a .e)  -> Int						| size_u e
	update				:: !* (a .e) !Int .e -> . (a .e)			| update_u e	
	uselect				:: ! u:(a e) !Int -> (e, ! u:(a e)) 		| uselect_u e
	usize				:: ! u:(a .e) -> (!Int, ! u:(a .e))			| usize_u e

instance Array { } default, {!}, {#}

class createArrayc_u e	:: !Int -> . {# .e }
class updatei_u e		:: !(!*{# .e },!*{x}) !Int .e -> *{x}
class uselectf_u e		:: ! u:{ # .e } !Int -> (!.e, ! u:{ #.e })
class uselectl_u e		:: !(!.{# e},!.{x}) !.Int -> (e,!.{x})
class uselectn_u e		:: !(!.{# .e},!.{x}) !.Int -> (.e,!.{x}) 
class createArray_u e	:: !Int !e -> . {# e }
class replace_u e		:: ! * {# .e } !Int !.e -> (!.e, ! * {# .e })
class select_u e 		:: !   { #.e } !Int -> .e
class size_u e			:: !   { #.e } -> Int
class update_u e		:: ! * { #.e } !Int !.e -> . { #.e }
class uselect_u e		:: ! u:{ # e } !Int -> (!e, ! u:{ #e })
class usize_u e			:: ! u:{ #.e } -> (!Int, ! u:{ #.e })

instance createArrayc_u	a, Int, Real, Char, Bool, File
instance updatei_u		a, Int, Real, Char, Bool, File
instance uselectf_u		a, Int, Real, Char, Bool, File
instance uselectl_u		a, Int, Real, Char, Bool, File
instance uselectn_u		a, Int, Real, Char, Bool, File
instance createArray_u	a, Int, Real, Char, Bool, File
instance select_u		a, Int, Real, Char, Bool, File
instance size_u			a, Int, Real, Char, Bool, File
instance replace_u		a, Int, Real, Char, Bool, File
instance update_u		a, Int, Real, Char, Bool, File
instance uselect_u		a, Int, Real, Char, Bool, File
instance usize_u		a, Int, Real, Char, Bool, File

class ArrayElem a | select_u, uselect_u, uselectf_u, uselectn_u, uselectl_u, size_u, usize_u,
					update_u, updatei_u, createArray_u, createArrayc_u, replace_u a
